"use strict";
var __defProp = Object.defineProperty;
var __getOwnPropDesc = Object.getOwnPropertyDescriptor;
var __getOwnPropNames = Object.getOwnPropertyNames;
var __hasOwnProp = Object.prototype.hasOwnProperty;
var __export = (target, all) => {
  for (var name in all)
    __defProp(target, name, { get: all[name], enumerable: true });
};
var __copyProps = (to, from, except, desc) => {
  if (from && typeof from === "object" || typeof from === "function") {
    for (let key of __getOwnPropNames(from))
      if (!__hasOwnProp.call(to, key) && key !== except)
        __defProp(to, key, { get: () => from[key], enumerable: !(desc = __getOwnPropDesc(from, key)) || desc.enumerable });
  }
  return to;
};
var __toCommonJS = (mod) => __copyProps(__defProp({}, "__esModule", { value: true }), mod);

// src/binders.ts
var binders_exports = {};
__export(binders_exports, {
  input: () => input
});
module.exports = __toCommonJS(binders_exports);
function onUpdate(computed, cb, initial = false) {
  if (initial)
    cb(computed.get());
  return computed.observe(() => cb(computed.get()));
}
function input(node, value) {
  const subscription = onUpdate(value, (ref) => node.value = ref.get(), true);
  const listener = () => value.get().set(node.value);
  node.addEventListener("input", listener);
  return {
    destroy() {
      node.removeEventListener("input", listener);
      subscription.revoke();
    }
  };
}
