import { Task, Ticker } from './scheduler';
export type SubscriptionListener = () => void;
export interface Subscription {
    revoke(): void;
}
export type Extender = (cb: () => void) => void;
type Link = [target: object, key: string | symbol];
export interface Reference<T = unknown> {
    get(): T;
    set(value: T): void;
    observe(listener: SubscriptionListener): Subscription;
}
export interface ModelOptions {
    ticker?: Ticker;
}
export declare function attach(target: Model, property: PropertyKey): void;
export declare function extend(extender: Extender): (target: Model, property: PropertyKey) => void;
export declare function ignore(...args: [target: Model, property: PropertyKey]): void;
export declare abstract class Model {
    protected $ticker: Ticker;
    protected $schedule(task: Task, dedup?: Link): void;
    private $scheduleEmit_;
    protected $tick(): void;
    protected $observe(target: unknown, listener: SubscriptionListener): Subscription;
    protected $notify(target: unknown): void;
    protected $ref<T>(target: T): Reference<T>;
    protected $silent<T>(target: T): T;
    abstract dispose?(): void;
    constructor(options?: ModelOptions);
}
export {};
